'--------------------------------------------------------------
'                 (c) 2011 Dipl.-Ing. Dieter Laues
'           NETZLUPE zur Anzeige von Netzfrequenz-Abweichungen
'--------------------------------------------------------------
'  "Powerline-Magnifier"
'  (to display frequency-deviation of Main-Power)
'  Controller : 89c2051
'  Compiler  : Bascom 8051
'  Quarz     : 12MHz
'  Version   : 1.00
'  modified by Raymond Vermeulen for 60Hz areas
'--------------------------------------------------------------


Dim Tact As Word                                              'Actual period of Mains in s
Dim Tlast As Word                                             'Last Timer-value
Dim Dif As Word
Dim Value As Word                                             'Actual Timer-value
Dim Value_l As Byte
Dim Value_h As Byte
Dim Counts As Byte
Dim Sumcounts As Long



'Init Timer-Interrupt
'--------------------
On Int0 Int0_interrupt                                        'vector to interrupt-routine
Set Tcon.0                                                    'trigger to falling edge
Config Timer0 = Timer , Gate = Internal , Mode = 1            '16bit INT0
Enable Timer0
Start Timer0
Enable Interrupts


'LED-test on power-up
'--------------------
Reset P1.7                                                    'switch on every LED
Waitms 250                                                    'for a short period
Set P1.7

Reset P1.6
Waitms 250
Set P1.6

Reset P1.5
Waitms 250
Set P1.5

Reset P1.4
Waitms 250
Set P1.4

Reset P1.3
Waitms 250
Set P1.3

Reset P1.2
Waitms 250
Set P1.2

Reset P1.1
Waitms 250
Set P1.1

Reset P1.0
Waitms 250
Set P1.0

Reset P3.4
Waitms 250
Set P3.4

Reset P3.5
Waitms 250
Set P3.5

Reset P3.7
Waitms 250
Set P3.7

Enable Int0                                                   'start frequency-counter


Counts = 0


'main-loop
'---------

Do

If Counts = 60 Then                                           'after 60 measurements
   Tact = Sumcounts / 60                                      'averaging over 1s
   Set P3.7                                                   'all LEDs off
   Set P3.5
   Set P3.4
   P1 = 255

   If Tact >= 16722 Then                                      '<59,800 Hz
      Reset P3.7
   End If

   If Tact >= 16694 And Tact < 16722 Then                     '59,900 Hz
      Reset P3.5
   End If

   If Tact >= 16687 And Tact < 16694 Then                     '59,925 Hz
      Reset P3.4
   End If

   If Tact >= 16681 And Tact < 16687 Then                     '59,950 Hz
      Reset P1.0
   End If

   If Tact >= 16674 And Tact < 16681 Then                     '59,975 Hz
      Reset P1.1
   End If

   If Tact > 16660 And Tact < 16674 Then                      '60,000 Hz
      Reset P1.2
   End If

   If Tact > 16653 And Tact <= 16660 Then                     '60,025 Hz
      Reset P1.3
   End If

   If Tact > 16646 And Tact <= 16653 Then                     '60,050 Hz
      Reset P1.4
   End If

   If Tact > 16639 And Tact <= 16646 Then                     '60,075 Hz
      Reset P1.5
   End If

   If Tact > 16611 And Tact <= 16639 Then                     '60,100 Hz
      Reset P1.6
   End If

   If Tact <= 16611 Then                                      '>60,200 Hz
      Reset P1.7
   End If


   Counts = 0
   Sumcounts = 0
   Reset P3.3                                                 'flashing activity-LED
   Waitms 100
   Set P3.3
End If

Loop



Int0_interrupt:                                               'Interrupt on neg. edge Pin INT1
'--------------
Intstart:
Value_h = Th0                                                 'save timer-values on the fly
Value_l = Tl0
If Value_h <> Th0 Then Goto Intstart

Value = Value_h * 256
Value = Value + Value_l


If Value > Tlast Then                                         'difference to last timervalue
   Dif = Value - Tlast
Else
   Dif = Value + &H10000
   Dif = Dif - Tlast
End If

If Dif > 15385 And Dif < 18182 Then                           'regarding values only between 55...65Hz
   Sumcounts = Sumcounts + Dif
   Incr Counts
End If

Tlast = Value
Return

End

nop
nop
nop